apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ ksm_name }}
  name: {{ ksm_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ ksm_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ ksm_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ ksm_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      containers:
      - env:
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='kubestatemetrics'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='kubestatemetrics'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 19
          httpGet:
            path: /healthz
            port: 8080
          initialDelaySeconds: 5
          timeoutSeconds: 4
        name: kube-state-metrics
        ports:
        - containerPort: 8080
          name: http-metrics
        - containerPort: 8081
          name: telemetry
        readinessProbe:
          httpGet:
            path: /
            port: 8081
          initialDelaySeconds: 5
          timeoutSeconds: 4
        resources:
          limits:
            cpu: "{{ kubestatemetrics_cpu_limit }}"
            memory: "{{ kubestatemetrics_memory_limit }}"
          requests:
            cpu: "{{ kubestatemetrics_cpu_request }}"
            memory: "{{ kubestatemetrics_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
      serviceAccountName: {{ ksm_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='kubestatemetrics'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - kube-state-metrics
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='kubestatemetrics'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
